## net.sf.saxon.functions
Interface FunctionLibrary

All Superinterfaces:
  java.io.Serializable

All Known Implementing Classes:
  ConstructorFunctionLibrary, ExecutableFunctionLibrary, FunctionLibraryList, JavaExtensionLibrary, StylesheetFunctionLibrary, SystemFunctionLibrary, VendorFunctionLibrary, XPathFunctionLibrary, XQueryFunctionLibrary

public interface FunctionLibrary
extends java.io.Serializable

A FunctionLibrary handles the binding of function calls in XPath (or XQuery) expressions. There are a number of implementations of this class to handle different kinds of function: system functions, constructor functions, vendor-defined functions, Java extension functions, stylesheet functions, and so on. There is also an implementation `FunctionLibraryList` that allows a FunctionLibrary to be constructed by combining other FunctionLibrary objects.

Method Summary
`Expression` `bind(int nameCode, java.lang.String uri, java.lang.String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`boolean` `isAvailable(int fingerprint, java.lang.String uri, java.lang.String local, int arity)` Test whether an extension function with a given name and arity is available.

Method Detail

### isAvailable

    public boolean isAvailable(int fingerprint,
                               java.lang.String uri,
                               java.lang.String local,
                               int arity)

  Test whether an extension function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Parameters:
    `fingerprint` - The namepool fingerprint of the function name. This must match the uri and localName; the information is provided redundantly to avoid repeated lookups in the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.

### bind

    public Expression bind(int nameCode,
                           java.lang.String uri,
                           java.lang.String local,
                           Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Parameters:
    `nameCode` - The namepool nameCode of the function name. The uri and local name are also supplied (redundantly) to avoid fetching them from the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
  Returns:
    An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.